
package de.ivu.elect.business.stimmzettel.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractStimmzettelEdit {

  @Inject
  protected StimmzettelDAO dao;

  @Inject
  protected StimmzettelExtendedDAO extendedDao;

  public void delete(Stimmzettel entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Stimmzettel entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Stimmzettel entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Stimmzettel getAttachedEntity(Stimmzettel entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Stimmzettel getAttachedAndRefreshedEntity(Stimmzettel entity) {
    return dao.refresh(entity);
  }
}
